/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_ccp.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_ccp.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/
/*****************************************************************************
 ** \brief	CCP_Capture_Mode0_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void CCP_Capture_Mode0_Config(void)
{
	/*
	(1)CCPʱ
	*/
	SYS_EnablePeripheralClk(SYS_CLK_CCP_MSK);							/*CCPģʱ*/
	CCP_ConfigCLK(CCP0,CCP_CLK_DIV_64,CCP_RELOAD_CCPLOAD,4800);			/*Fccp = 48Mhz /64 = 0.75Mh -> = 4800/0.75Mhz = 6400us*/
																		/*CCP0ģֵΪ4800*/
	/*
	(2)CCPģʽ
	*/
	CCP_EnableCAPMode0(CCP0);											/*CCP0ĹģʽΪģʽ0*/
	CCP_ConfigCAPMode0(CCP0,CCP_CAP_MODE0_RISING_TO_FALLING);			/*CCP0Ĳģʽ0 ĲʽΪص½(ߵƽʱ)*/
																		/*/½زCCPģʹ(CCPRUN =1)󣬼ֵ4800(ֵ)¼ֹͣ浱ǰļֵ*/
													/*½زCCPģʹ(CCPRUN =1)󣬵ʱֵ4800(ֵ)¼(½)ֹͣ浱ǰļֵ*/
													/*½زCCPģʹ(CCPRUN =1)󣬵½ʱֵ4800(ֵ)¼()ֹͣ浱ǰļֵ*/
	/*
	(3)CCPͨ
	*/
	CCP_SelCAPMode0Channel(CCP0,CCPxA);									/*òͨΪCCPA0*/
	SYS_SET_IOCFG(IOP04CFG, SYS_IOCFG_P04_CCP0A);						/*P04ΪCCPA0ͨ*/
	/*
	(4)CCPж
	*/	
	CCP_EnableOverflowInt(CCP0);					/*CCP0ģж*/
	CCP_EnableCAPMode0Int(CCP0);				    /*CCP0ģ鲶ģʽ0ж*/
	NVIC_EnableIRQ(CCP_IRQn);		
	/*
	(5)CCP жȼ
	*/	
	NVIC_SetPriority(CCP_IRQn,3);					/*ȼ0~3 0ߡ3*/		
	/*
	(6)CCPģ
	*/	
	CCP_EnableRun(CCP0);			
	CCP_Start(CCP0);			/*CCP0ģʹ*/			
}




