/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_ccp.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_ccp.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/
/*****************************************************************************
 ** \brief	CCP_Capture_Mode2_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void CCP_Capture_Mode2_Config(void)
{
	/*
	(1)CCPʱ
	*/
	SYS_EnablePeripheralClk(SYS_CLK_CCP_MSK);						/*CCPģʱ*/
	CCP_ConfigCLK(CCP1,CCP_CLK_DIV_64,CCP_RELOAD_CCPLOAD,4800);		/*Fccp = 48Mhz /64 = 0.75Mh -> = 4800/0.75Mhz = 6400us*/
	
	/*
	(2)CCPģʽ
	*/
	CCP_EnableCAPMode2();								/*CCPģ鹤ģʽΪģʽ2*/
	CCP_ConfigCAPMode2(CAP1,CCP_CAP_MODE2_RISING);		
	CCP_ConfigCAPMode2(CAP2,CCP_CAP_MODE2_FALLING);
	CCP_ConfigCAPMode2(CAP3,CCP_CAP_MODE2_RISING);

	/*
	(3)CCPͨ
	*/
	CCP_SelCAPMode2Channel(ECAP03);						/*CAP1ͨѡⲿECAP03ӿ*/
	SYS_SET_IOCFG(IOP36CFG, SYS_IOCFG_P36_ECAP03);		/*P36ΪECAP03*/
	/*
	(4)CCPж
	*/		
	CCP_EnableCAPMode1Int(CAP3);					  
	NVIC_EnableIRQ(CCP_IRQn);	
	/*
	(5)CCP жȼ
	*/	
	NVIC_SetPriority(CCP_IRQn,3);					/*ȼ0~3 0ߡ3*/		
	/*
	(6)CCPģ
	*/	
	CCP_EnableRun(CCP1);			
	CCP_Start(CCP1);				
}




