/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_ccp.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_ccp.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	CCP_50_DUTY_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void CCP_50_DUTY_Config(void)
{
	/*
	(1)CCPʱ
	*/
	SYS_EnablePeripheralClk(SYS_CLK_CCP_MSK);						/*CCPģʱ*/
	CCP_ConfigCLK(CCP0,CCP_CLK_DIV_1,CCP_RELOAD_CCPLOAD,4800);		/*Fahb=48M, Pccp0 = 100us*/
	CCP_ConfigCLK(CCP1,CCP_CLK_DIV_1,CCP_RELOAD_CCPLOAD,4800);		/*Fahb=48M, Pccp1 = 100us*/	
	/*
	(2)CCPģʽ
	*/
	CCP_EnablePWMMode(CCP0);		/*CCP0ΪPWMģʽ*/
	CCP_EnablePWMMode(CCP1);		/*CCP1ΪPWMģʽ*/
	/*
	(3)50%ռձ
	*/	
	CCP_EnablePWMHalfCycleMode(CCP0,CCPxA);
	CCP_EnablePWMHalfCycleMode(CCP0,CCPxB);	
	CCP_EnablePWMHalfCycleMode(CCP1,CCPxA);	
	CCP_EnablePWMHalfCycleMode(CCP1,CCPxB);	
	/*
	(4)CCP 
	*/		
	CCP_DisableReverseOutput(CCP0,CCPxA);	/*رշ*/
	CCP_DisableReverseOutput(CCP0,CCPxB);  
	CCP_DisableReverseOutput(CCP1,CCPxA);  
	CCP_DisableReverseOutput(CCP1,CCPxB);
	/*
	(5)CCP ж`
	*/	
	CCP_EnableOverflowInt(CCP0);			/*CCP0ж*/
	CCP_EnableOverflowInt(CCP1);			/*CCP1ж*/	
	NVIC_EnableIRQ(CCP_IRQn);
	/*
	(6)CCP жȼ
	*/	
	NVIC_SetPriority(CCP_IRQn,3);					/*ȼ0~3 0ߡ3*/	

	/*
	(7)CCP IOڸ
	*/	
	SYS_SET_IOCFG(IOP04CFG, SYS_IOCFG_P04_CCP0A);	
	SYS_SET_IOCFG(IOP05CFG, SYS_IOCFG_P05_CCP0B);	
	SYS_SET_IOCFG(IOP06CFG, SYS_IOCFG_P06_CCP1A);	
	SYS_SET_IOCFG(IOP07CFG, SYS_IOCFG_P07_CCP1B);	
	/*
	(8)CCPģ
	*/	
	CCP_EnableRun(CCP0);			
	CCP_EnableRun(CCP1);		
	CCP_Start(CCP0);			/*CCP0ģʹ*/
	CCP_Start(CCP1);			/*CCP1ģʹ*/			

}



























