/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file main.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "cms32f0301.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/
uint8_t CrcDataTab[16] = {0};
uint16_t CrcResult;


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	 CRC_16_CCITT
 **
 ** \param [in]  DataTab: ݳʼַ   
 **              length
 ** \return 0
*****************************************************************************/
uint16_t  CRC_16_CCITT(uint8_t *DataTab, uint32_t length);

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	 main
 **
 ** \param [in]  none   
 **
 ** \return 0
*****************************************************************************/
int main(void)
{		
	uint32_t i;
	
 	SYS_DisableIOCFGProtect();			/*رIOCONFIGд*/
	SYS_DisableGPIO0Protect();			/*رGPIO0ؼĴд*/
	SYS_DisableGPIO1Protect();			/*رGPIO1ؼĴд*/
	SYS_DisableGPIO2Protect();			/*رGPIO2ؼĴд*/
	SYS_DisableGPIO3Protect();			/*رGPIO3ؼĴд*/
	SYS_DisableGPIO4Protect();			/*رGPIO4ؼĴд*/
	
	SYS_ConfigHSI(SYS_CLK_HSI_48M);		/*ڲʱΪ48Mhz*/
	SYS_EnableHSI();					/*ʱ*/
	SYS_ConfigAHBClock(SYS_CLK_SEL_HSI,SYS_CLK_DIV_1);	/*AHBʱΪʱӵ1Ƶ*/
	SYS_ConfigAPBClock(AHB_CLK_DIV_1);					/*APBʱΪAHBʱӵ1Ƶ*/
	SystemCoreClockUpdate();						/*ˢSystemCoreCLkSystemAPBClockֵ*/
	SYS->APBCKEN = 0;									/*ʱ*/
	SYS_EnablePeripheralClk(SYS_CLK_CRC_MSK);
	
	/***************01516CRC**************/
	for(i=0;i<16;i++)
	{
		CrcDataTab[i]= i;
	}
	CrcResult = CRC_16_CCITT(CrcDataTab,16);
	/***************ݲοֲ**************/
	CrcDataTab[3] = 0x12;
	CrcDataTab[2] = 0x34;
	CrcDataTab[1] = 0x56;
	CrcDataTab[0] = 0x78;
	CrcResult = CRC_16_CCITT(CrcDataTab,4);
	
	while(1)
	{	
		;
	}		
}



/*****************************************************************************
 ** \brief	 CRC_16_CCITT
 **
 ** \param [in]  DataTab: ݳʼַ   
 **              length
 ** \return 0
*****************************************************************************/
uint16_t  CRC_16_CCITT(uint8_t *DataTab, uint32_t length)
{
	uint32_t i;
	CRC_Reset();
	
	for(i=0;i<length;i++)
	{
		CRC_Input(*DataTab);			
		DataTab ++;
	}
	return (CRC_Output());
}














