/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file main.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "cms32f0301.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/
unsigned char  APROM_DataTab8[20] ={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19};
uint32_t  APROM_DataTab[20] ={0};
uint32_t  APROM_StartAddr = 0xFC00;		
uint32_t  APROM_StopAddr = 0xFFFFF;

uint32_t  DATA_DataTab[20] ={0};
uint32_t  DATA_StartAddr = 0x1C000000;		
uint32_t  DATA_StopAddr = 0x1C0003FF;

uint32_t  DataBuf[20] ={0};
uint16_t  CRCResult=0;

/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/



/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	 main
 **
 ** \param [in]  none   
 **
 ** \return 0
*****************************************************************************/
int main(void)
{		
	uint32_t  Count;
	
 	SYS_DisableIOCFGProtect();			/*رIOCONFIGд*/
	SYS_DisableGPIO0Protect();			/*رGPIO0ؼĴд*/
	SYS_DisableGPIO1Protect();			/*رGPIO1ؼĴд*/
	SYS_DisableGPIO2Protect();			/*رGPIO2ؼĴд*/
	SYS_DisableGPIO3Protect();			/*رGPIO3ؼĴд*/
	SYS_DisableGPIO4Protect();			/*رGPIO4ؼĴд*/
	
	SYS_ConfigHSI(SYS_CLK_HSI_48M);		/*ڲʱΪ48Mhz*/
	SYS_EnableHSI();					/*ʱ*/
	SYS_ConfigAHBClock(SYS_CLK_SEL_HSI,SYS_CLK_DIV_1);	/*AHBʱΪʱӵ1Ƶ*/
	SYS_ConfigAPBClock(AHB_CLK_DIV_1);					/*APBʱΪAHBʱӵ1Ƶ*/
	SystemCoreClockUpdate();						/*ˢSystemCoreCLkSystemAPBClockֵ*/
	SYS->APBCKEN = 0;									/*ʱ*/	

	Count =0;	
	for(Count=0; Count<20;Count++)
	{
		APROM_DataTab[Count] = Count+1;	
	}
		
	/*APROM */
	FMC_ErasePage(APROM_StartAddr);
	/*APROM д*/	
	for(Count=0; Count<20;Count++)
	{
		FMC_Write(APROM_StartAddr + Count*4 , APROM_DataTab[Count]);	
	}	
//	ProgramPage(APROM_StartAddr, 20, (unsigned char*)&APROM_DataTab8);
	/*APROM */		
	for(Count=0; Count<20;Count++)
	{
		DATA_DataTab[Count] = FMC_Read(APROM_StartAddr + Count*4);	
	}	
	
	/*DATA */
	FMC_ErasePage(DATA_StartAddr);	
	
	/*DATA д*/
	for(Count=0; Count<20;Count++)
	{
		FMC_Write(DATA_StartAddr + Count*4 , DATA_DataTab[Count]);	
	}	
	
	/*DATA */
	for(Count=0; Count<20;Count++)
	{
		DataBuf[Count] = FMC_Read(DATA_StartAddr + Count*4);		
	}	
		
	/*CRCУ飨ֻAPROM*/		
	CRCResult = FMC_CRC(APROM_StartAddr, APROM_StartAddr);
	
	
	while(1)
	{	
		;
	}	
	
}
















