/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file main.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "cms32f0301.h"
#include "demo_gpio.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/
void GPIO_Sleep(void);
/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/


/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/
void Delay(unsigned long Num)
{
	unsigned long i;
	for(i=0;i<Num;i++)
	{;}
}
/*****************************************************************************
 ** \brief	 main
 **
 ** \param [in]  none   
 **
 ** \return 0
*****************************************************************************/
int main(void)
{		
	
 	SYS_DisableIOCFGProtect();			/*رIOCONFIGд*/
	SYS_DisableGPIO0Protect();			/*رGPIO0ؼĴд*/
	SYS_DisableGPIO1Protect();			/*رGPIO1ؼĴд*/
	SYS_DisableGPIO2Protect();			/*رGPIO2ؼĴд*/
	SYS_DisableGPIO3Protect();			/*رGPIO3ؼĴд*/
	SYS_DisableGPIO4Protect();			/*رGPIO4ؼĴд*/
	
	SYS_ConfigHSI(SYS_CLK_HSI_48M);		/*ڲʱΪ48Mhz*/
	SYS_EnableHSI();					        /*ʱ*/
	SYS_ConfigAHBClock(SYS_CLK_SEL_HSI,SYS_CLK_DIV_1);	/*AHBʱΪʱӵ1Ƶ*/
	SYS_ConfigAPBClock(AHB_CLK_DIV_1);					/*APBʱΪAHBʱӵ1Ƶ*/
	SystemCoreClockUpdate();	

	GPIO_Sleep();
	GPIO_Config();
	GPIO1->DO_f.P2 = 1;			    /*P12ߵƽ*/	

	SYS_EnterDeepSleepLowPowerMode();
	while(1)
	{	
			GPIO1->DO_f.P2 = 0;			/*P12͵ƽ*/		
			Delay(100);
			GPIO1->DO_f.P2 = 1;			/*P12ߵƽ*/		
			Delay(100);
	}
		
}
/**/δʹ/δװĹܽҪΪù̶ƽ***************/
void GPIO_Sleep(void)
{
	SYS->IOP00CFG= 0X00;			//Set to GPIO
	SYS->IOP01CFG= 0X00;
	SYS->IOP04CFG= 0X00;
	SYS->IOP05CFG= 0X00;
	SYS->IOP06CFG= 0X00;
	SYS->IOP07CFG= 0X00;
	
	SYS->IOP10CFG= 0X00;			//Set to GPIO
	SYS->IOP12CFG= 0X00;
	SYS->IOP13CFG= 0X00;
	SYS->IOP14CFG= 0X00;
	SYS->IOP15CFG= 0X00;
	SYS->IOP16CFG= 0X00;
	SYS->IOP17CFG= 0X00;
	
	SYS->IOP21CFG= 0X00;			//Set to GPIO
	SYS->IOP22CFG= 0X00;
//	SYS->IOP23CFG= 0X00;    //ԿڻӰ칦ģҪĸͣҪѵԿó
//	SYS->IOP24CFG= 0X00;
	SYS->IOP25CFG= 0X00;
	SYS->IOP26CFG= 0X00;
	
	SYS->IOP30CFG= 0X00;			//Set to GPIO
	SYS->IOP31CFG= 0X00;
	SYS->IOP32CFG= 0X00;
	SYS->IOP34CFG= 0X00;
	SYS->IOP35CFG= 0X00;
	SYS->IOP36CFG= 0X00;
	
	SYS->IOP40CFG= 0X00;			//Set to GPIO
	SYS->IOP43CFG= 0X00;
	SYS->IOP44CFG= 0X00;
	SYS->IOP46CFG= 0X00;
	SYS->IOP47CFG= 0X00;

	
	GPIO0->PMS =0X11111111;  //out mode
	GPIO0->DO =0x00;				 //out low
	
	GPIO1->PMS =0X11111111;  //out mode
	GPIO1->DO =0x00;				 //out low
	
	GPIO2->PMS =0X11100111;  //out mode
	GPIO2->DO =0x00;				 //out low
	
	GPIO3->PMS =0X11111111;  //out mode
	GPIO3->DO =0x00;				 //out low
	
	GPIO4->PMS =0X11111111;  //out modeԿڱ̬
	GPIO4->DO =0x00;				 //out low
	
}
















