/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_gpio.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_gpio.h"
/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	GPIO_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void GPIO_Config(void)
{
	/*
	(1)P13Ϊģʽ
	*/
	SYS_SET_IOCFG(IOP13CFG,SYS_IOCFG_P13_GPIO);			/*P13ΪGPIOģʽ*/	
	GPIO_CONFIG_IO_MODE(GPIO1,GPIO_PIN_3,GPIO_MODE_INPUT_WITH_PULL_UP);		
	/*
	(2)P13жΪ½жģʽ
	*/	
	GPIO_EnableInt(GPIO1,GPIO_PIN_3_MSK,GPIO_INT_EDGE_FALLING);
	/*
	(3)P13 IO˲		
	*/		
	GPIO_EnableFilter(GPIO1,GPIO_PIN_3_MSK,GPIO_FILCLK_9);
	/*
	(4)GPIO1ж
	*/
	GPIO_ClearIntFlag(GPIO1,GPIO_PIN_3);	/*P13жϱ־λ*/
	NVIC_EnableIRQ(GPIO1_IRQn);				    /*GPIO1ж*/
	/*
	(5)GPIO1жȼ
	*/	
	NVIC_SetPriority(GPIO1_IRQn,3);			  /* 0~3, 0, 3*/
	
	
	/*
	(6)P12Ϊģʽ(չʾ˳),ʹùĸ
	*/
	SYS_SET_IOCFG(IOP12CFG,SYS_IOCFG_P12_GPIO); /*P12ΪGPIOģʽ*/	
	GPIO_CONFIG_IO_MODE(GPIO1,GPIO_PIN_2,GPIO_MODE_OUTPUT); /*P12Ϊģʽ*/								 
	GPIO_RESET_PIN(GPIO1,GPIO_PIN_2_MSK);       /*P12͵ƽ*/
}



