/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_uart.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_uart.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	UART0_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void  UART0_Config(void)
{	

	/*
	1.UART ģʽ
	*/
	UART_ConfigRunMode(UART0, 9600, UART_WLS_8, UART_PARITY_NONE,UART_STOP_BIT_1);
	
	UART_EnableAuto(UART0);
	UART_EnableFIFO(UART0,FIFO_L0_1BYTE, FIFO_L0_1BYTE, FIFO_RST_EN, FIFO_RST_EN);	
	
	/*
	2.UART ʱ
	*/	
	SYS_EnablePeripheralClk(SYS_CLK_UART0_MSK);
	/*
	3.UART ӿ
	*/	
	SYS_SET_IOCFG(IOP13CFG,SYS_IOCFG_P13_TXD0);	
	SYS_SET_IOCFG(IOP12CFG,SYS_IOCFG_P12_RXD0);	
	/*
	4.UART ж
	*/	
	
	UART_EnableTHREInt(UART0);
	UART_EnableRBRInt(UART0);
	NVIC_SetPriority(UART0_IRQn,3);	
	NVIC_EnableIRQ(UART0_IRQn); 

}

